%global         date 2022.12.01
%global         live_soversion 0

Name:           live
Version:        %{date}
Release:        2%{?dist}
Summary:        LIVE555 Streaming Media
URL:            http://www.live555.com/liveMedia/
License:        LGPLv2+
Group:          System Environment/Libraries
Source0:        http://www.live555.com/liveMedia/public/live.%{version}.tar.gz
#Patch0:         live.2017.06.04-shared.patch
BuildRequires:  gcc-c++, perl, openssl-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
This code forms a set of C++ libraries for multimedia streaming, using
open standard protocols (RTP/RTCP, RTSP, SIP).

%package devel
Summary: LIVE555 Streaming Media Development Tools
Group: Development/Libraries
Requires: live = %{version}-%{release}

%description devel
Development tools for the LIVE555 Streaming Media libraries.

%package utils
Summary: LIVE555 Streaming Media Utilities
Group: Development/Libraries
Requires: live = %{version}-%{release}

%description utils
A set of test programs for the LIVE555 Streaming Media libraries.

%prep
%setup0 -q -n live
[ -f /usr/include/xlocale.h ] || ln -s /usr/include/locale.h /usr/include/xlocale.h
install -pm 0644 config.linux config.linux.static
#%patch0 -p1 -b .shared

%build
./genMakefiles %{_target_os}.static
make %{?_smp_mflags} CFLAGS="$RPM_OPT_FLAGS"
mv $(find BasicUsageEnvironment groupsock liveMedia UsageEnvironment -name "*.a" ) $(pwd)
make clean

./genMakefiles %{_target_os}-with-shared-libraries
make CFLAGS="$RPM_OPT_FLAGS -fPIC -DPIC" SO_VERSION="%{live_soversion}"

%install
rm -rf $RPM_BUILD_ROOT
install -dm 755 $RPM_BUILD_ROOT{%{_libdir},%{_bindir}}
for i in BasicUsageEnvironment groupsock liveMedia UsageEnvironment ; do
  install -dm 755 $RPM_BUILD_ROOT%{_includedir}/$i
  install -pm 644 $i/include/*.h* $RPM_BUILD_ROOT%{_includedir}/$i/
  install -pm 644 lib${i}.a $RPM_BUILD_ROOT%{_libdir}/lib${i}.a
  install -pm 755 $i/lib${i}.so.* $RPM_BUILD_ROOT%{_libdir}/
  echo `ls $i/lib${i}.so.*`
  pushd $RPM_BUILD_ROOT%{_libdir}
  ln -sf lib${i}.so.* lib${i}.so.%{live_soversion}
  ln -sf lib${i}.so.%{live_soversion} lib${i}.so
  popd
done

install -pm755 mediaServer/live555MediaServer $RPM_BUILD_ROOT%{_bindir}

pushd testProgs
for i in \
  MPEG2TransportStreamIndexer \
  openRTSP \
  playSIP \
  sapWatch \
  testAMRAudioStreamer \
  testMP3Receiver \
  testMP3Streamer \
  testMPEG1or2AudioVideoStreamer \
  testMPEG1or2ProgramToTransportStream \
  testMPEG1or2Splitter \
  testMPEG1or2VideoReceiver \
  testMPEG1or2VideoStreamer \
  testMPEG2TransportStreamTrickPlay \
  testMPEG2TransportStreamer \
  testMPEG4VideoStreamer \
  testOnDemandRTSPServer \
  testRelay \
  testWAVAudioStreamer \
  vobStreamer \
; do
  install -pm755 $i $RPM_BUILD_ROOT%{_bindir}
done
popd

#RPM Macros support
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rpm
cat > $RPM_BUILD_ROOT%{_sysconfdir}/rpm/macros.live555 << EOF
# live555 RPM Macros
%live555date    %{date}
EOF
touch -r COPYING $RPM_BUILD_ROOT%{_sysconfdir}/rpm/macros.live555


%clean
#rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%{_libdir}/libBasicUsageEnvironment.so.*
%{_libdir}/libBasicUsageEnvironment.so
%{_libdir}/libgroupsock.so.*
%{_libdir}/libgroupsock.so
%{_libdir}/libliveMedia.so.*
%{_libdir}/libliveMedia.so
%{_libdir}/libUsageEnvironment.so.*
%{_libdir}/libUsageEnvironment.so

%files devel
%defattr(-,root,root,-)
%defattr(-,root,root,-)
%doc COPYING README
%config %{_sysconfdir}/rpm/macros.live555
%{_includedir}/BasicUsageEnvironment/
%{_includedir}/groupsock/
%{_includedir}/liveMedia/
%{_includedir}/UsageEnvironment/

%{_libdir}/libBasicUsageEnvironment.so.*
%{_libdir}/libBasicUsageEnvironment.so
%{_libdir}/libgroupsock.so.*
%{_libdir}/libgroupsock.so
%{_libdir}/libliveMedia.so.*
%{_libdir}/libliveMedia.so
%{_libdir}/libUsageEnvironment.so.*
%{_libdir}/libUsageEnvironment.so

%{_libdir}/libBasicUsageEnvironment*.a
%{_libdir}/libgroupsock*.a
%{_libdir}/libliveMedia*.a
%{_libdir}/libUsageEnvironment*.a

%files utils
%defattr(-,root,root)
%{_bindir}/*

%changelog
* Wed Jan 11 2023 Stephen Collier <stephenbcollier@gmail.com> - 2022.12.01
- Update to 2022.12.01.

* Mon Oct 22 2018 Stephen Collier <stephenbcollier@gmail.com> - 2018.10.17
- Update to 2018.10.17.

* Sat Nov 25 2017 Stephen Collier <stephenbcollier@gmail.com> - 2017.10.28
- Update to 2017.10.28.

* Fri Jul 14 2017 Stephen Collier <stephenbcollier@gmail.com> - 2017.06.04
- Update to 2017.06.04.

* Mon Feb 27 2012 Paulo Roma <roma@lcg.ufrj.br> - 2012.02.04-1
- Update to 2012.02.04.

* Sun Apr 19 2009 Axel Thimm <Axel.Thimm@ATrpms.net> - 2009.04.07-12
- Update to 2009.04.07.

* Tue May 27 2008 Paulo Roma <roma@lcg.ufrj.br> 2008.05.12-11
- Update to 2008.05.12

* Sun Apr 20 2008 Paulo Roma <roma@lcg.ufrj.br> 2008.04.09-11
- Update to 2008.04.09

* Sat Feb 02 2008 Paulo Roma <roma@lcg.ufrj.br> 2008.01.19-11
- Update to 2008.01.19

* Wed Oct 17 2007 Paulo Roma <roma@lcg.ufrj.br> 2007.08.03a-11
- Stripped libraries break mplayer build. Undoing.

* Sat Oct 13 2007 Paulo Roma <roma@lcg.ufrj.br> 2007.08.03a-10
- Update to 2007.08.03a.
- Changed license to LGPLv2.
- Stripped static libraries.

* Tue Feb 21 2007 Paulo Roma <roma@lcg.ufrj.br> 2007.05.24-9
- Update to 2007.05.24.

* Tue Feb 21 2007 Paulo Roma <roma@lcg.ufrj.br> 2007.02.20-9
- Update to 2007.02.20.

* Sun Jan  8 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 2006.01.05.

* Fri Oct  1 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 2004.09.30.

* Sun Apr 11 2004 Axel Thimm <Axel.Thimm@ATrpms.net>
- Updated to 2004.04.09.

* Tue Oct  7 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- Updated to 2003.10.07.

* Mon Apr  7 2003 Axel Thimm <Axel.Thimm@ATrpms.net>
- Rebuilt for Red Hat 9.

* Thu Jan 23 2003 Jeffrey C. Ollie <jcollie@pc04771.dmacc.cc.ia.us>
- Updated to 2003.01.17
- Added test utilities
- Reorganized and formed into subpackages
- Patched to remove deprecated header warnings
- Patched makefiles to use RPM optimization flags

* Mon Aug 12 2002 Jeffrey C. Ollie <jcollie@pc04771.dmacc.cc.ia.us>
- Initial build.

